DEFINT A-Z
SCREEN 12
PALETTE 0, 3276800

'Calculates a PALETTE colr& number.     **** IMPORTANT ****
'                                     Program uses LINE INPUT and
'                                     several steps of string
'                                     analysis to accept and deal
'                                     with input errors of all
'                                     types without encurring the
'                                     error message,"Redo From The
'                                     Start. "
Again:
CLS
LOCATE 5, 13: PRINT "PALETTE colr& NUMBER FROM 16 COLOR R, G, B VALUES."
LOCATE 9, 14: PRINT "Enter values (0 - 63) for Red, Green, and Blue"
LOCATE 10, 17: LINE INPUT "separated by commas: R, G, B = ", d$
  
 ' First if D$ is non printing character (Escape, Enter, etc.), Quit
   IF d$ = "" THEN COLOR 14: LOCATE 10, 51: PRINT "EXIT": SLEEP 2: CLS : END

 ' Then, look for 2 commas in D$, the comma delimited input string.
      Start = 1                         'Examine from 1st character
      match = 0                         'Match counters set to zero
      numMatch = 0
       DO                               'Search and count
        match = INSTR(Start, d$, ",")
        IF match > 0 THEN
          'PRINT TAB(match); D$
          Start = match + 1
          numMatch = numMatch + 1
        END IF
       LOOP WHILE match

  ' Test, is the comma count, 2.
       IF numMatch <> 2 THEN BEEP: GOTO Again

  ' Ok, 2 commas, there should be three integers in the string
     
  ' Extract strings between the delimiters
      delim = INSTR(d$, ",")  'locate first comma
      R$ = LEFT$(d$, delim - 1)                 'R string
      Gb$ = RIGHT$(d$, LEN(d$) - delim)
      delim = INSTR(Gb$, ",")
      G$ = LEFT$(Gb$, delim - 1)                'G string
      B$ = RIGHT$(Gb$, LEN(Gb$) - delim)        'B string

  ' If any of the three strings are absent Goto Again, try over.
      IF R$ = "" OR G$ = "" OR B$ = "" THEN BEEP: GOTO Again

  ' Make numbers of the strings and calculate colr&

  ' But first make certain the strings are numeric figures, in the proper range
      R1$ = LEFT$(R$, 1): IF R1$ < CHR$(48) OR R1$ > CHR$(57) THEN BEEP: GOTO Again
      R2$ = RIGHT$(R$, 1): IF R1$ < CHR$(48) OR R1$ > CHR$(57) THEN BEEP: GOTO Again
      R = VAL(R$): IF R < 0 OR R > 63 THEN BEEP: GOTO Again

      G1$ = LEFT$(G$, 1): IF G1$ < CHR$(48) OR G1$ > CHR$(57) THEN BEEP: GOTO Again
      G2$ = RIGHT$(G$, 1): IF G1$ < CHR$(48) OR G1$ > CHR$(57) THEN BEEP: GOTO Again
      G = VAL(G$): IF G < 0 OR G > 63 THEN BEEP: GOTO Again
     
      B1$ = LEFT$(B$, 1): IF B1$ < CHR$(48) OR B1$ > CHR$(57) THEN BEEP: GOTO Again
      B2$ = RIGHT$(B$, 1): IF B1$ < CHR$(48) OR B1$ > CHR$(57) THEN BEEP: GOTO Again
      B = VAL(B$): IF B < 0 OR B > 63 THEN BEEP: GOTO Again

  ' Make colr& number from the user input
      Colr& = R + G * 256 + B * 65536
      LOCATE 13, 14: PRINT "colr& ="; Colr&
         Rb = R: Gb = G: Bb = B     ' Reserve the colors for later restore

  ' Demonstrate the resulting color in a filled proof box outlined white
      PALETTE 6, Colr&
      LINE (252, 175)-STEP(230, 64), 6, BF
      LINE (251, 174)-STEP(232, 66), 15, B

  ' Show Syntax on screen for completeness
      LOCATE 17, 14: PRINT "Syntax: PALETTE [Attribute, colr&]"
      LINE (0, 413)-(639, 413), 15
      LOCATE 28, 10: PRINT "Press Enter to start over"
      LOCATE 28, 50: PRINT "Press ESC to quit"

  ' Stand by to exit or re run with a change in R, G, B value.
      LOCATE 19, 14: PRINT "To adjust the color to other R, G, B values:"
      LOCATE 20, 16: PRINT "o   Press R, G, or B"
      LOCATE 21, 16: PRINT "o   Then cursor arrow up or down to increment."
      LOCATE 22, 16: PRINT "o   Press another color and continue"

      LOCATE 24, 14: PRINT "To restore the original mix of color, press X."
'------------------------------------------------------------------------
  'The DO-LOOP structure below is devoted to interpreting keystrokes
  'and revising R-G-B input, color number and the color proof box.

   DO
     Action = 0
     Ky$ = INKEY$
     IF LEN(Ky$) = 1 THEN keycode = ASC(Ky$)

     SELECT CASE keycode

          CASE 82, 114                                   'Red
                COLOR 13: LOCATE 10, 38: PRINT "R"
                          LOCATE 20, 26: PRINT "R"
                          LOCATE 10, 48: WRITE R, G, B
                DO
                  Ky$ = INKEY$                  'Up down or out
                  IF LEN(Ky$) = 1 THEN
                     keycode = ASC(Ky$)
                  ELSEIF LEN(Ky$) = 2 THEN
                     keycode = -ASC(RIGHT$(Ky$, 1))
                  END IF
                  IF keycode = -72 THEN                  'Red cont.
                      IF R < 63 THEN R = R + 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = -80 THEN
                      IF R > 0 THEN R = R - 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = 66 OR keycode = 71 OR keycode = 98 OR keycode = 103 THEN
                      Action = 1
                  ELSEIF keycode = 88 OR keycode = 120 THEN
                      R = Rb: G = Gb: B = Bb
                      Action = 1
                      keycode = 0
                  END IF                                 'Red cont.
                  Colr& = R + G * 256 + B * 65536
                  PALETTE 6, Colr&
                  LOCATE 13, 21: PRINT Colr&
                LOOP UNTIL Action = 1 OR Ky$ = CHR$(27)
                COLOR 15: LOCATE 10, 38: PRINT "R"
                          LOCATE 10, 48: WRITE R, G, B
                          LOCATE 20, 26: PRINT "R"
                          LOCATE 13, 21: PRINT Colr&
          CASE 71, 103                                   'Green
                COLOR 13: LOCATE 10, 41: PRINT "G"
                          LOCATE 20, 29: PRINT "G"
                          LOCATE 10, 48: WRITE R, G, B
                DO
                  Ky$ = INKEY$                  'Up down or out
                  IF LEN(Ky$) = 1 THEN
                     keycode = ASC(Ky$)
                  ELSEIF LEN(Ky$) = 2 THEN
                     keycode = -ASC(RIGHT$(Ky$, 1))
                  END IF
                  IF keycode = -72 THEN                  'Green cont.
                      IF G < 63 THEN G = G + 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = -80 THEN
                      IF G > 0 THEN G = G - 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = 66 OR keycode = 82 OR keycode = 98 OR keycode = 114 THEN
                      Action = 1
                  ELSEIF keycode = 88 OR keycode = 120 THEN
                      R = Rb: G = Gb: B = Bb
                      Action = 1
                      keycode = 0
                  END IF                                 'Green cont.
                  Colr& = R + G * 256 + B * 65536
                  PALETTE 6, Colr&
                  LOCATE 13, 21: PRINT Colr&
                LOOP UNTIL Action = 1 OR Ky$ = CHR$(27)
                COLOR 15: LOCATE 10, 41: PRINT "G"
                          LOCATE 10, 48: WRITE R, G, B
                          LOCATE 20, 29: PRINT "G"
                          LOCATE 13, 21: PRINT Colr&
          CASE 66, 98                                    'Blue
                COLOR 13: LOCATE 10, 44: PRINT "B"
                          LOCATE 20, 35: PRINT "B"
                          LOCATE 10, 48: WRITE R, G, B
                DO
                  Ky$ = INKEY$                  'Up down or out
                  IF LEN(Ky$) = 1 THEN
                     keycode = ASC(Ky$)
                  ELSEIF LEN(Ky$) = 2 THEN
                     keycode = -ASC(RIGHT$(Ky$, 1))
                  END IF
                  IF keycode = -72 THEN                  'Blue cont.
                      IF B < 63 THEN B = B + 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = -80 THEN
                      IF B > 0 THEN B = B - 1
                      LOCATE 10, 48: PRINT "         "
                      LOCATE 10, 48: WRITE R, G, B
                      keycode = 0
                  ELSEIF keycode = 71 OR keycode = 82 OR keycode = 103 OR keycode = 114 THEN
                      Action = 1
                  ELSEIF keycode = 88 OR keycode = 120 THEN
                      R = Rb: G = Gb: B = Bb
                      Action = 1
                      keycode = 0
                  END IF                                 'Blue cont.
                  Colr& = R + G * 256 + B * 65536
                  PALETTE 6, Colr&
                  LOCATE 13, 21: PRINT Colr&
                LOOP UNTIL Action = 1 OR Ky$ = CHR$(27)
                COLOR 15: LOCATE 10, 44: PRINT "B"
                          LOCATE 10, 48: WRITE R, G, B
                          LOCATE 20, 35: PRINT "B"
                          LOCATE 13, 21: PRINT Colr&
     END SELECT
     IF Ky$ = CHR$(13) GOTO Again
   LOOP UNTIL Ky$ = CHR$(27)
   CLS
   PALETTE       'Sets colors to default and forces the computer to
                 'recover it's default screen.
END



